use crate::abort;

unsafe extern "C" fn _enter() {
    
    let id = riscv::register::mhartid::read();
    write_tp(&id);
    // TODO: set up stack for all harts
    // TODO: set up CSRs for all harts
    if id != 0 { abort(); }

    // TODO: clear BSS
    // TODO: do hardware inits and wake other harts
}

#[inline]
unsafe fn write_tp(id: &usize) {
    use core::arch::asm;
    asm!(
        "csrw mhartid, {id}",
        id = in(reg) id,
    );
}